package extensions

import data.{Cons, Nil}
import org.scalatest.matchers.must.Matchers
import org.scalatest.wordspec.AnyWordSpecLike

class LispListSpec extends AnyWordSpecLike with Matchers {

  "LispList" can {

    /**
      * Exercise: Create a length method
      */
    "length" which {
      "returns 0 if the list is Nil" in {
        val lispList = Nil
        pending
        //lispList.length should eq(0)
      }
      "returns the length of the list" in {
        val lispList = Cons(1, Cons(2, Cons(3, Nil)))
        pending
        //lispList.length should eq(3)
      }
    }

    /**
      * Exercise: Create a schrodingersCar method
      */
    "schrodingersCar" which {
      "returns Dead" when {
        "list is Nil" in {
          val lispList = Nil
          pending
          //lispList.schrodingersCar should eq(Dead)
        }
      }
      "returns Alive containing the first value" when {
        "the list is not Nil" in {
          val lispList = Cons("Ferrari", Cons("Lamborghini", Cons("Honda Fit", Nil)))
          pending
          //lispList.schrodingersCar should eq(Alive("Ferrari"))
        }
      }
    }
  }
}
